﻿clear,clc
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%     Universidad Tecnológica Nacional      %%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%           Facultal Regional Rosario       %%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%         Matemática Suprior Aplicada       %%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%             Prof: A. Santa Cruz           %%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Programa fondo de retiro.
// Planteo del problema: Un ingeniero químico percibe al inicio de su actividad profesional un salario anual de
// $ 250.000.Cada año coloca x% de su salario en una cuenta de retiro que se ajusta por inflación. 
// Si el ingeniero percibe un aumento salarial promedio anual del 30%, la inflación promedio anual es del 20% y
// el fondo de retiro paga un 26% de interés anual ¿Qué porcentaje x de su salario debe afectar anualmente para
// alcanzar un monto de $4.000.000 en el fondo de retiro en pesos corrientes después de 40 años de actividad?
sleep(3,"s")
// Mediande la function retiro.sce calculamos el capital de una cuenta de retiro en función de la tasa de ahorro. 
// Esta tasa la definimos mediante el vector x.
sleep(3,"s")
// Para llamar a la function escribimos [r,s]=retiro(x,s,ts,ti,tr), 
// donde: 
// x  representa diferentes porcentaje del salario que deben depositarse, 
// s  el salario inicial, 
// ts el aumento salarial anual que recibe (en %), 
// ti el ajuste por inflación y
// tr el interés anual que paga el fondo de retiro
sleep(1,"s")
//Ingreso de fichero de datos con los valores de s, ts, ti, tr y M
load('datos.dat');
s,ts,ti,tr,M
// Con estos datos podemos calcular el porcentaje en que debemos afectar anualmente el salario del ingeniero para 
// obtener el monto M luego de trabajar durante 40 años. Se grafica el monto acumulado en la cuenta de retiro en 
// función del porcentaje anual que debe retirar de su sueldo.
sleep(5,"s")
x=0:.1:30;//Se define un vector de porcentajes
// Se llama a la function retiro(x,s,ts,ti,tr) que calcula el fondo de retiro al cabo de 40 años.
//function [r,s]= retiro(x,s,ts,ti,tr)
function [r,s]= retiro(x,s,ts,ti,tr)
r = s*x/100;
for i=2:40;
s = s*(1 + ts/100)*(1 - ti/100);
r = r*(1 + tr/100)*(1 - ti/100)+s.*x/100;
end;
endfunction
[r,s]= retiro(x,s,ts,ti,tr);
plot(x,r)
xlabel('Tasa de interés, %')
ylabel('Capital acumulado, $')
set(gca(),'grid',[1 1])
// Con el mouse cliqueamos sobre la gráfica para obtener el valor aproximado del monto pretendido al cabo de 40 // años de trabajo.
disp('Cliquear sobre la gráfica el punto correspondiente al monto solicitado')
p = locate(1);
disp("Coordenadas x e y del punto");
disp([p(1);p(2)]);
sleep(10,"s")
// Se observa que la tasa anual de ahorro es del 15%
// Otra manera es determinar la mínima componente del vector diferencia = abs((M-r)
sleep(3,"s")
disp("Se observa que la tasa anual de ahorro es del 15%");
disp("Otra manera es determinar la mínima componente del vector abs(M-r)");
diferencia=abs(M-r);
[xy,i]=min(diferencia);
disp("La tasa de ahorro es: ");
disp(x(i));

function [r,s]= retiro(x,s,ts,ti,tr)
r = s*x/100;
for i=2:40;
s = s*(1 + ts/100)*(1 - ti/100);
r = r*(1 + tr/100)*(1 - ti/100)+s.*x/100;
end;
endfunction
